<!doctype html>
<html <?php language_attributes(); ?>>
<head>
<meta charset="utf-8">
<title>
<?php if (is_home()){
	bloginfo('name'); echo " - " ; bloginfo('description');
}elseif (is_category()){
	single_cat_title(); echo ' -  ' ; bloginfo('name');
}elseif (is_single()){
	single_post_title(); echo ' - ' ; bloginfo('name');
}elseif (is_page()){
	bloginfo('name'); echo ': '; single_post_title();
}
elseif (is_author()){
	bloginfo('name'); echo ' - Posts by ' ; wp_title('',true);
}
elseif (is_tag()){
	bloginfo('name'); echo ' - Tag: ' ; wp_title('',true);
}
elseif (is_search()){
	bloginfo('name'); echo ' - ' ; wp_title('',true);
}
elseif (is_404()){
	bloginfo('name'); echo ' - ' ; wp_title('',true);
}
else {
	wp_title('',true);
} ?>
</title>

<style type="text/css" media="screen">
		@import url( <?php bloginfo('stylesheet_url'); ?> );
</style>

<?php wp_head(); ?>
</head>

<body <?php body_class($class); ?>>
<?php include (TEMPLATEPATH . '/the-excerpt-re-reloaded/the_excerpt_rereloaded.php'); ?>

	<div id="box">

		<div id="content-box">

			<header class="headerTop" style="background: url(<?php header_image(); ?>);">

				<div id="sitename">

						<h1>
							<a href="<?php echo home_url(); ?>"><?php bloginfo('name'); ?></a>
						</h1>

						<h2><?php bloginfo('description'); ?></h2>

				</div><!--sitename-->

				<div id="search">

					<form role="search" method="get" id="searchform" action="<?php echo home_url(); ?>">
						<input value="" name="s" id="s" type="text">
						<input id="searchsubmit" value="" type="submit" class="btnSearch">
					</form>

				</div><!--search-->

			</header>

			<nav class="menu">

				<div id="cssmenu">

				<?php //wp_nav_menu(); ?>

				<?php 
					wp_nav_menu(array(
  						'menu' => 'Main Menu', 
  						'container_id' => 'cssmenu', 
 						'walker' => new CSS_Menu_Maker_Walker()
					)); 
				?>

				</div>

			</nav>